﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private Thread threadOne;
        private Thread threadTwo;
        private Thread threadObserver;
        private AutoResetEvent autoEventOne = new AutoResetEvent(false);
        private AutoResetEvent autoEventTwo = new AutoResetEvent(false);
        private Boolean threadOneExit = false;
        private Boolean threadTwoExit = false;
        private Boolean formClosing = false;
        private delegate void StringArgReturningVoidDelegate(string connectionStatus);
        private object lockObject = new object();


        private void SetOperationStatusOne(string usedTimeValueStatus)
        {

            if (this.textBoxThreadOneAlive.InvokeRequired)
            {
                StringArgReturningVoidDelegate d = new StringArgReturningVoidDelegate(SetOperationStatusOne);
                this.Invoke(d, new object[] { usedTimeValueStatus });
            }
            else
            {
                this.textBoxThreadOneAlive.Text = usedTimeValueStatus;
            }
        }

        private void SetOperationStatusTwo(string usedTimeValueStatus)
        {
            if (this.textBoxThreadTwoAlive.InvokeRequired)
            {
                StringArgReturningVoidDelegate d = new StringArgReturningVoidDelegate(SetOperationStatusTwo);
                this.Invoke(d, new object[] { usedTimeValueStatus });
            }
            else
            {
                this.textBoxThreadTwoAlive.Text = usedTimeValueStatus;
            }
        }

        private void SetTotalThreadCount(string usedTimeValueStatus)
        {
            if (this.textBoxTotalThreadRunning.InvokeRequired)
            {
                StringArgReturningVoidDelegate d = new StringArgReturningVoidDelegate(SetTotalThreadCount);
                this.Invoke(d, new object[] { usedTimeValueStatus });
            }
            else
            {
                this.textBoxTotalThreadRunning.Text = usedTimeValueStatus;
            }
        }

        private void SetOperationStatusWhatDoesOne(string usedTimeValueStatus)
        {
            if (this.textBoxWhatDoesOne.InvokeRequired)
            {
                StringArgReturningVoidDelegate d = new StringArgReturningVoidDelegate(SetOperationStatusWhatDoesOne);
                this.Invoke(d, new object[] { usedTimeValueStatus });
            }
            else
            {
                this.textBoxWhatDoesOne.Text = usedTimeValueStatus;
            }
        }

        private void SetOperationStatusWhatDoesTwo(string usedTimeValueStatus)
        {
            if (this.textBoxWhatDoesTwo.InvokeRequired)
            {
                StringArgReturningVoidDelegate d = new StringArgReturningVoidDelegate(SetOperationStatusWhatDoesTwo);
                this.Invoke(d, new object[] { usedTimeValueStatus });
            }
            else
            {
                this.textBoxWhatDoesTwo.Text = usedTimeValueStatus;
            }
        }



        public Form1()
        {
            InitializeComponent();

            this.FormClosing += Form1_FormClosing;

            threadOne = new Thread(WorkMethodOne);
            threadTwo = new Thread(WorkMethodTwo);
            threadOne.Start(autoEventOne);
            threadTwo.Start(autoEventTwo);
            threadObserver = new Thread(MonitorInfo);
            threadObserver.Start();
        }

        private void MonitorInfo()
        {

            bool b = true;
            while (b)
            {
                lock (lockObject)
                {
                    if (formClosing == true)
                    {
                        b = false;
                    }
                }

                if (threadOne.IsAlive)
                {
                    SetOperationStatusOne("Alive");
                }
                else
                {
                    SetOperationStatusOne("Dead");
                }
                if (threadTwo.IsAlive)
                {
                    SetOperationStatusTwo("Alive");
                }
                else
                {
                    SetOperationStatusTwo("Dead");
                }
                Thread.Sleep(100);

                //string newText = "abc";
                //this.textBoxTotalThreadRunning.Invoke((MethodInvoker)delegate {
                //    // Running on the UI thread
                //    this.textBoxTotalThreadRunning.Text = newText;
                //});

                SetTotalThreadCount(System.Diagnostics.Process.GetCurrentProcess().Threads.Count.ToString());

            }
        }
        private void WorkMethodOne(object stateInfo)
        {
            bool b = true;
            while (b)
            {
                lock (lockObject)
                {
                    b = !threadOneExit;
                }
                SetOperationStatusWhatDoesOne("Thread one Blocked");
                autoEventOne.WaitOne();
                SetOperationStatusWhatDoesOne("Work starting for one.");
                Thread.Sleep(5000);
                SetOperationStatusWhatDoesOne("Work done for this round for thread One.");
                Thread.Sleep(1000);
                // ((AutoResetEvent)stateInfo).Set();
            }
        }

        private void WorkMethodTwo(object stateInfo)
        {
            bool b = true;
            while (b)
            {
                lock (lockObject)
                {
                    b = !threadTwoExit;
                }
                SetOperationStatusWhatDoesTwo("Thread two blocked");
                autoEventTwo.WaitOne();
                SetOperationStatusWhatDoesTwo("Work starting for two.");
                Thread.Sleep(5000);
                SetOperationStatusWhatDoesTwo("Work done for this round for thread  two.");
                Thread.Sleep(1000);
                //((AutoResetEvent)stateInfo).Set();
            }
        }

        private void buttonSet_Click(object sender, EventArgs e)
        {
            autoEventOne.Set();
        }

        private void buttonReset_Click(object sender, EventArgs e)
        {
            autoEventTwo.Set();
        }

        private void buttonFunctionOneExit_Click(object sender, EventArgs e)
        {
            lock (lockObject)
            {
                threadOneExit = true;
            }
        }

        private void buttonFunctionTwoExit_Click(object sender, EventArgs e)
        {
            lock (lockObject)
            {
                threadTwoExit = true;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {          
            lock (lockObject)
            {
                formClosing = true;
            }

        }

    }
}
